<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8">
<title>TipsAndTricks/UnableToEnableDMAonCD</title>
<link rel="stylesheet" type="text/css" media="all" charset="utf-8" href="modern/css/common.css">
<link rel="stylesheet" type="text/css" media="screen" charset="utf-8" href="modern/css/screen.css">
<link rel="stylesheet" type="text/css" media="print" charset="utf-8" href="modern/css/print.css">
<style type="text/css">
ul.pagetitle{
  display: inline;
  margin: 0;
  padding: 0;
  font-size: 1.5em;
}
li.pagetitle{
  display: inline;
  margin: 0;
}
td.noborder {
  border: 0;
}
</style>
</head>
<body>
<table>
<tr>
<td class="noborder">
<img src="logo.png">
</td>
<td class="noborder">
<ul class="pagetitle">
<li class="pagetitle"><a class="backlink">TipsAndTricks/UnableToEnableDMAonCD</a>
</ul>
<br><br>
[<a href="FrontPage.html">FrontPage</a>]&nbsp;[<a href="TitleIndex.html">TitleIndex</a>]&nbsp;[<a href="WordIndex.html">WordIndex</a>]&nbsp;
</td>
</tr>
</table>
<hr>
<div id="page"><h1 style="background-color:Red; color:White">This is a read-only <a href="https://gitlab.com/CentOS/docs/wiki_archives">archived version</a> of wiki.centos.org</h1>
<div dir="ltr" id="content" lang="en"><span class="anchor" id="top"></span>
<span class="anchor" id="line-1"></span><span class="anchor" id="line-2"></span><span class="anchor" id="line-3"></span><p class="line867">
<h1 id="Unable_To_Enable_DMA_on_CD_or_DVD_Drive">Unable To Enable DMA on CD or DVD Drive</h1>
<span class="anchor" id="line-4"></span><span class="anchor" id="line-5"></span><p class="line867">
<h2 id="Problem">1. Problem</h2>
<span class="anchor" id="line-6"></span><span class="anchor" id="line-7"></span><p class="line874">The command: <span class="anchor" id="line-8"></span><span class="anchor" id="line-9"></span><p class="line874">{{{# hdparm -d /dev/hdc <span class="anchor" id="line-10"></span>}}}  <span class="anchor" id="line-11"></span><span class="anchor" id="line-12"></span><p class="line874">reports that DMA is disabled. Attempting to enable DMA on an optical drive with: <span class="anchor" id="line-13"></span><span class="anchor" id="line-14"></span><p class="line867"><span class="anchor" id="line-15"></span><pre><span class="anchor" id="line-1"></span># hdparm -d1 /dev/hdc</pre><span class="anchor" id="line-16"></span><span class="anchor" id="line-17"></span><p class="line862">Yields an <tt>Operation&nbsp;Not&nbsp;Permitted</tt> error.  <span class="anchor" id="line-18"></span><span class="anchor" id="line-19"></span><p class="line867">
<h2 id="Solution">2. Solution</h2>
<span class="anchor" id="line-20"></span><span class="anchor" id="line-21"></span><p class="line862">Add the following line to <tt>/etc/modprobe.conf</tt>: <span class="anchor" id="line-22"></span><span class="anchor" id="line-23"></span><p class="line867"><span class="anchor" id="line-24"></span><pre><span class="anchor" id="line-1-1"></span>options libata atapi_enabled=1</pre><span class="anchor" id="line-25"></span><span class="anchor" id="line-26"></span><p class="line862">Add the following boot parameter to your kernel in <tt>grub.conf</tt>: <span class="anchor" id="line-27"></span><span class="anchor" id="line-28"></span><p class="line867"><span class="anchor" id="line-29"></span><pre><span class="anchor" id="line-1-2"></span>combined_mode=libata</pre><span class="anchor" id="line-30"></span><span class="anchor" id="line-31"></span><p class="line862">So an <em><strong>example</em></strong> of a <tt>kernel</tt> line in your <tt>grub.conf</tt> <em><strong>might</strong></em> look like: <span class="anchor" id="line-32"></span><span class="anchor" id="line-33"></span><p class="line867"><span class="anchor" id="line-34"></span><pre><span class="anchor" id="line-1-3"></span>kernel /boot/vmlinuz-2.6.18-8.1.8.el5 ro root=LABEL=/ rhgb quiet combined_mode=libata</pre><span class="anchor" id="line-35"></span><span class="anchor" id="line-36"></span><p class="line862">Reboot after making these changes. The <tt>/dev</tt> entry for your drive will change from <tt>/dev/hdx</tt> to <tt>/dev/scd0</tt>. <span class="anchor" id="line-37"></span><span class="anchor" id="line-38"></span><p class="line867">
<h2 id="Explanation">3. Explanation</h2>
<span class="anchor" id="line-39"></span><span class="anchor" id="line-40"></span><p class="line874">This problem apparently goes back to Fedora 5. However the author of this page was only hit with this problem during a new installation of CentOS 5. Given the lineage of this problem, this solution is probably applicable to CentOS 4 as well. <span class="anchor" id="line-41"></span><span class="anchor" id="line-42"></span><p class="line862">The issue is that ICH7 based motherboards somehow emulate standard IDE controllers. The kernel's default IDE driver doesn't correctly operate this emulated controller. The above changes tell the kernel to use the newer <tt>libata</tt> driver. See the links below for more information. <span class="anchor" id="line-43"></span><span class="anchor" id="line-44"></span><p class="line867">
<h2 id="References">4. References</h2>
<span class="anchor" id="line-45"></span><span class="anchor" id="line-46"></span><ul><li><p class="line891"><a class="http" href="http://www.fedoraforum.org/forum/showthread.php?t=114586">http://www.fedoraforum.org/forum/showthread.php?t=114586</a> <span class="anchor" id="line-47"></span></li><li><p class="line891"><a class="http" href="http://www.serpentine.com/blog/2006/12/12/make-linux-happy-with-a-modern-laptops-cddvd-drive/">http://www.serpentine.com/blog/2006/12/12/make-linux-happy-with-a-modern-laptops-cddvd-drive/</a> <span class="anchor" id="line-48"></span></li></ul><span class="anchor" id="bottom"></span></div>
</div>
<hr>
2023-09-11 07:23
</body>
</html>
